//#define MYTITLE	{mainwnd.cpp}
/**************************************************************************
   MODULE		:	mainwnd.cpp
   Version		:	2.0
   Description	:	This file contains the override for CWinApp
**************************************************************************/

#include "stdafx.h"
#include "mainwnd.h"
#include "GENERIC.h"	// for CGenericDlg definition


#ifdef _DEBUG
	#undef THIS_FILE
	static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#define new DEBUG_NEW


/////////////////////////////////////////////////////////////////////////////
// This is the one and only CGenericApp object.

CGenericApp NEAR app;

/////////////////////////////////////////////////////////////////////////////
// Message Map -- CGenericApp

BEGIN_MESSAGE_MAP(CGenericApp, CWinApp)
	//{{AFX_MSG_MAP(CGenericApp)
#if defined (_HELP) || defined (_ALLOPTIONS)
	ON_COMMAND(ID_HELP_INDEX, OnHelpIndex)
	ON_COMMAND(ID_HELP_USING, OnHelpUsing)
	ON_COMMAND(ID_HELP, OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, OnHelpIndex)
#endif //_HELP
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGenericApp::CGenericApp

CGenericApp::CGenericApp()
{      
}

/////////////////////////////////////////////////////////////////////////////
// CGenericApp::ExitInstance
//	ExitInstance is called by the application framework to exit an
//	instance of the Generic application.  It performs all clean up 
//	required by the application.

int CGenericApp::ExitInstance()
{
#if defined (_CTL3D) || defined (_ALLOPTIONS)
	Ctl3dUnregister(AfxGetInstanceHandle());
	::UnregisterClass("MyWindowClass", AfxGetInstanceHandle());
#endif	//_CTL3D
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// CGenericApp::InitApplication
//	InitApplication performs per-application initialization of the 
//	Generic application.  It registers a private window class for
//	the main application dialog.  By doing this, and by specifying the 
//	class name in the dialog template, we can associate an icon with 
//	the dialog.

BOOL CGenericApp::InitApplication()
{
	BOOL		bSuccess;
	WNDCLASS	wc;

	// Get normal dialog class information
	bSuccess = GetClassInfo(NULL, MAKEINTRESOURCE(0x8002), &wc);
   
	if (bSuccess)
	{
		// modify normal dialog class info to suit our needs
		wc.lpszClassName = "MyWindowClass";
		wc.style ^= CS_GLOBALCLASS;
		wc.hIcon = LoadIcon(IDR_MAIN);
		wc.hInstance = AfxGetInstanceHandle();
		bSuccess = (::RegisterClass(&wc) != 0) ? TRUE : FALSE;
	}
	return bSuccess;
}

/////////////////////////////////////////////////////////////////////////////
// CGenericApp::InitInstance
//	InitInstance performs per-instance initialization of the Generic
//	application.
#if defined (_LIMIT) || defined (_ALLOPTIONS)
//	If an instance of the application is already running, it activates
//	that instance.  Otherwise, it creates the modeless dialog which
//	serves as the application's interface.
#endif	//_LIMIT
//

BOOL CGenericApp::InitInstance()
{
	BOOL bSuccess = FALSE;

#if defined (_LIMIT) || defined (_ALLOPTIONS)
	CWnd *pwndFirst = CWnd::FindWindow("MyWindowClass", NULL);
   
	if (pwndFirst)
	{
		// another instance is already running -- activate it
		CWnd *pwndChild = pwndFirst->GetLastActivePopup();
		pwndFirst->BringWindowToTop();
		if (pwndFirst != pwndChild)
			pwndChild->BringWindowToTop();
		if (pwndFirst->IsIconic())
			pwndFirst->ShowWindow(SW_SHOWNORMAL);
	}
	else
	{
		// this is the first instance -- create the dialog
#endif // _LIMIT
#if defined (_CTL3D) || defined (_ALLOPTIONS)
		Ctl3dRegister(AfxGetInstanceHandle());
		Ctl3dAutoSubclass(AfxGetInstanceHandle());
		
#endif	//_CTL3D
		TRY
		{
			m_pMainWnd = new CGenericDlg(this);
			bSuccess = TRUE;
		}
		CATCH_ALL(e)
		{
			bSuccess = FALSE;
		}
		END_CATCH_ALL
#if defined (_LIMIT) || defined (_ALLOPTIONS)
	}
	
#endif // _LIMIT
	return bSuccess;
}
    
#if defined (_ACCEL) || defined (_ALLOPTIONS)
/////////////////////////////////////////////////////////////////////////////
// Translate accelerator messages here. We will load the accelerator
//	table the first time the function is called.

BOOL CGenericApp::PreTranslateMessage(MSG *pMsg)
{
	static	HACCEL	m_hAccel=NULL;		// Accelerator handle

	if(!m_hAccel)
		m_hAccel=::LoadAccelerators(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MAIN_ACCEL));

	if(!TranslateAccelerator(m_pMainWnd->m_hWnd, m_hAccel, pMsg))
		return CWinApp::PreTranslateMessage(pMsg);
	else
		return TRUE;
}
#endif	//_ACCEL
